/**
 * @file   EasyMesh.h
 * @author Robert Lie
 * @date   Fri Jun 23 15:33:35 2003
 * 
 * @brief  
 * 
 * 
 */

#ifndef _EasyMesh_h_
#define _EasyMesh_h_

#include <iostream>
#include <string>
#include <fstream>

#include "Geometry.h"

/**
 * This class provides interface to input data from and output data out to the
 * triangulation data file generated by the grid generation software \p{easymesh}.
 */

template <int DOW>
class TriangleMesh: public Mesh<2,DOW>
{
public:
  TriangleMesh() {};
  TriangleMesh(const Mesh<2,DOW>&) {};
  ~TriangleMesh() {};
public:
  void readData(const std::string&);
  void writeData(const std::string&) const;
  DeclException1(ExcMeshData, 
		 char *, 
		 << "Mesh data error: " << arg1);
};

class EasyMesh : public TriangleMesh<2>
{
 public:
  void writeOpenDXData(const std::string&) const;
};


#endif //_EasyMesh_h_

/**
 * end of file
 * 
 */

