/**
 * @file   MemoryReclaimer.h
 * @author Robert Lie
 * @date   Sun Apr 29 15:48:52 2007
 * 
 * @brief  
 * 
 * 
 */

#ifndef _MemoryReclaimer_h_
#define _MemoryReclaimer_h_

#include "HGeometry.h"

/*!

  HGeometryTreeIrregularMeshУһHGeometryHElementϸ
  Ժǽ洢ڴУЩʱʹõʱ
  û̽ЩڴͷŵҪĿΪЩٴҪʱ
  򣬿Խʡʱ䡣ضʱЩʱ
  ڴջأԱʵ֣͵Ĵ£

  <pre>

    HGeometryTree<DIM,DOW> h_tree;
    ... ...
    IrregularMesh<DIM,DOW> ir_mesh_0;
    IrregularMesh<DIM,DOW> ir_mesh_1;
    ... ...
    MemoryReclaimer<DIM,DOW> mr(h_tree);
    mr.addIrregularMesh(ir_mesh_0);
    mr.addIrregularMesh(ir_mesh_1);
    mr.reclaim();

  </pre>

  ڵreclaim֮󣬲ʹõڴ潫ᱻա

  Ҫرעǣ˲ʱнh_treeϵġ󻹻ʹ
  IrregularMeshҪʹaddIrregularMesh 뵽յĹ
  УܳǱڵĴ

 */
template <int DIM, int DOW=DIM>
  class MemoryReclaimer {
 public:
 enum {dim = DIM, dow = DOW};

 typedef HGeometryTree<DIM,DOW> tree_t;
 typedef IrregularMesh<DIM,DOW> ir_mesh_t;
 private:
 tree_t * h_tree;
 std::list<ir_mesh_t *> ir_mesh;

 public:
 MemoryReclaimer() : h_tree(NULL) {}
 MemoryReclaimer(tree_t& _h_tree) : h_tree(&_h_tree) {}
 virtual ~MemoryReclaimer() {}

 public:
 /**
  * ýڴղHGeometryTree
  * 
  */
 void setGeometryTree(tree_t& _h_tree) {
   h_tree = &_h_tree;
 }
 /**
  * ӽһμӲIrregularMesh
  * 
  */
 void addIrregularMesh(ir_mesh_t& _ir_mesh) {
   if (&(_ir_mesh.geometryTree()) != h_tree) {
     std::cout << "warning: the irregular mesh added is not based on the geometry tree used."
     << std::endl;
   }
   ir_mesh.push_back(&_ir_mesh);
 }
 void clear() {
   h_tree = NULL;
   ir_mesh.clear();
 }
 /*!

   HGeometryTreeмм໥Ϊһǳӵṹ
   Ϊ˻ڴ棬ʹĲʵ֣

   1. ÿIrregularMeshвõڴлաǷǳ򵥵ģ
   ΪֻҪÿҶӽڵͨͨɾ͹ˣʵں
   reclaimIrregularMeshС

   2. HGeometryTreeемʹindex=-1ʶ
   initialTreeLabelнС

   3. еIrregularMeshĵԪõļ嶼±ʶΪ1
    labelIrregularMesh 

   4. HGeometryTreeеļбһıʶΪ-1
   üӦñɾһαʱǾͽ
   ʶ޸Ϊ-2-1ʾǵһʶΪ1ô
   ڱĳIrregularMeshʹãǲʲôһ
   ʶΪ-2ôѾٵڶαˣô
   ϶ϵǸָΪ NULL
   HGeometryTreeԭǸ״ṹݣǸҪɾ
   Ĳ֣ѾΪ״ṹ

   5. HGeometryTreeеļбһıʶΪ-2
   Ǿͽɾ45 reclaimTreeMemory ʵֵģ

 */
 void reclaim();

 private:
 void reclaimIrregularMesh(ir_mesh_t&);
 void initialTreeLabel();
 void labelIrregularMesh(ir_mesh_t&);
 void reclaimTreeMemory();

 template <int DIM1> void labelHGeometry(HGeometry<DIM1,DOW>&, int lab);
 template <int DIM1> void labelHGeometryRecursively(HGeometry<DIM1,DOW>& g, int lab);
 template <int DIM1> int relabelHGeometryRecursively(HGeometry<DIM1,DOW>& g);
 template <int DIM1> int reclaimHGeometryRecursively(HGeometry<DIM1,DOW>& g);

 void labelHGeometry(HGeometry<0,DOW>&, int lab);
 void labelHGeometryRecursively(HGeometry<0,DOW>& g, int lab);
 int relabelHGeometryRecursively(HGeometry<0,DOW>& g);
 int reclaimHGeometryRecursively(HGeometry<0,DOW>& g);

 virtual void 
 reclaimHGeometry(void * p_geo, int dim) const {
   switch (dim) {
   case 0: delete ((HGeometry<0,DOW> *)(p_geo)); break;
   case 1: delete ((HGeometry<1,DOW> *)(p_geo)); break;
   case 2: delete ((HGeometry<2,DOW> *)(p_geo)); break;
   case 3: delete ((HGeometry<3,DOW> *)(p_geo)); break;
   }
 }

 protected:
 tree_t * get_tree_ptr() const { return h_tree; }
};

#include "MemoryReclaimer.templates.h"

#endif // _MemoryReclaimer_h_

/**
 * end of file
 * 
 */
